package com.sun.jmx.snmp.internal;

import com.sun.jmx.snmp.SnmpUnknownModelLcdException;
import com.sun.jmx.snmp.SnmpUnknownSubSystemException;
import com.sun.jmx.snmp.SnmpEngineId;
import java.util.Hashtable;

public abstract class SnmpLcd
{
    private Hashtable<SnmpSubSystem, SnmpLcd.SubSysLcdManager> subs;
    
    public SnmpLcd() {
        this.subs = new Hashtable();
    }
    
    public abstract int getEngineBoots();
    
    public abstract String getEngineId();
    
    public abstract void storeEngineBoots(int p0);
    
    public abstract void storeEngineId(SnmpEngineId p0);
    
    public void addModelLcd(SnmpSubSystem snmpSubSystem, int n, SnmpModelLcd snmpModelLcd) {
        SnmpLcd.SubSysLcdManager value = (SnmpLcd.SubSysLcdManager)this.subs.get(snmpSubSystem);
        if (value == null) {
            value = new SnmpLcd.SubSysLcdManager();
            this.subs.put(snmpSubSystem, value);
        }
        value.addModelLcd(n, snmpModelLcd);
    }
    
    public void removeModelLcd(SnmpSubSystem key, int i) throws SnmpUnknownModelLcdException, SnmpUnknownSubSystemException {
        SnmpLcd.SubSysLcdManager subSysLcdManager = (SnmpLcd.SubSysLcdManager)this.subs.get(key);
        if (subSysLcdManager != null) {
            if (subSysLcdManager.removeModelLcd(i) == null) {
                throw new SnmpUnknownModelLcdException("Model : " + i);
            }
            return;
        }
        else {
            throw new SnmpUnknownSubSystemException(key.toString());
        }
    }
    
    public SnmpModelLcd getModelLcd(SnmpSubSystem key, int n) {
        SnmpLcd.SubSysLcdManager subSysLcdManager = (SnmpLcd.SubSysLcdManager)this.subs.get(key);
        if (subSysLcdManager == null) {
            return null;
        }
        return subSysLcdManager.getModelLcd(n);
    }
    
    class SubSysLcdManager
    {
        private Hashtable<Integer, SnmpModelLcd> models;
        
        SubSysLcdManager() {
            this.models = new Hashtable();
        }
        
        public void addModelLcd(int value, SnmpModelLcd value2) {
            this.models.put(new Integer(value), value2);
        }
        
        public SnmpModelLcd getModelLcd(int value) {
            return (SnmpModelLcd)this.models.get(new Integer(value));
        }
        
        public SnmpModelLcd removeModelLcd(int value) {
            return (SnmpModelLcd)this.models.remove(new Integer(value));
        }
    }
}
